; #####################################
; #         Lionel d'Hauenens         #
; # -= http://www.labo-asso.com/ =- #
; #####################################


; ***************************************
; *             STRUCTURES              *
; ***************************************
descriptor STRUC
    _size   dw ?
    base    dd ?
descriptor ENDS

; ***************************************
; *              MACRO                  *
; ***************************************
GetCurrentThread MACRO reg
CurrentThread         equ 0124h   ; KPCR.PrcbData.CurrentThread (pointeur KTHREAD)
    mov reg, dword ptr fs:[CurrentThread]
ENDM
; ----------------------------------------
GetCurrentProcess MACRO reg
CurrentProcess    equ 044h   ; KTHREAD.ApcState.Process (pointeur KPROCESS)
    GetCurrentThread reg
    mov reg, dword ptr [reg+CurrentProcess]
ENDM
; ----------------------------------------
GetProcessAffinity MACRO reg
Affinity          equ 05Ch    ; KPROCESS.Affinity
    GetCurrentProcess reg
    mov reg, dword ptr [reg+Affinity]   ; KPROCESS.Affinity
ENDM
; ----------------------------------------
GetExportPointer MACRO reg, export_name
; manip qui permet de rcuprer l'adresse relle
; d'une fonction ou d'un data import.
; MASM -> jmp dword ptr [xxxxxxxx]
    
    lea reg, dword ptr [export_name + 2] ; saute l'opcode jmp
    mov reg, dword ptr [reg]
    mov reg, dword ptr [reg] 
ENDM

; ***************************************
; *                CODE                 *
; ***************************************
; * Sauve les descripteurs complets des
; * IDT et GDT ! (size + base) : 2 + 4 = 6 bytes
; *
; * push offset table_gdt   (table de fword) -> table_gdt df 20h dup(0)
; * push offset table_idt   (table de fword) -> table_idt df 20h dup(0)
; * call passive_level_save_all_idt_gdt
; *
; * retour :
; *    -> eax  = 0 : SUCCESS
; *    -> eax != 0 : ERREUR
; *
; ***************************************

passive_level_save_all_idt_gdt :

    pushad

    mov edi, dword ptr [esp+024h+0] ; table_idt
    mov esi, dword ptr [esp+024h+4] ; table_gdt

    push 0      ; original_affinity
    push 0      ; \ buf_descriptor
    push 0      ; /

original_affinity   equ     <esp+(2*4)>
buf_descriptor      equ     <esp>

; -------- Sauver le mask d'affinit du process --------
    GetProcessAffinity ebx

; -------- Activer le mask courant pour le premier processeur --------
    xor ebp, ebp
    inc ebp             ; mask

; -------- sauver le nombre de proceseur --------
    GetExportPointer eax, <KeNumberProcessors> 
    movzx ecx, byte ptr [eax]               ; cl = NumberProcessors
   
Boucle_save_all_idt_gdt :

; -------- Vrifier la compatibilit du mask --------
; -------- avec l'affinity du process        --------
        mov eax, ebx
        and eax, ebp
        sub eax, ebp
        jne erreur_save_all_idt_gdt

; -------- Imposer un processeur au thread --------
        push ecx
            GetCurrentThread eax
            push ebp            ; Mask
            push eax            ; Thread
            call KeSetAffinityThread
        pop ecx

; -------- Sauver l'affinity originale si premier passage --------
        cmp dword ptr [original_affinity], 0
        jne @F
            mov dword ptr [original_affinity], eax
    @@ :    
; -------- Sauve l'IDT courante --------
        sidt dword ptr [buf_descriptor]
        mov ax, word ptr [buf_descriptor].descriptor._size
        mov word ptr [edi], ax
        mov eax, dword ptr [buf_descriptor].descriptor.base
        mov dword ptr [edi+2], eax

; -------- Sauve la GDT courante --------
        sgdt dword ptr [buf_descriptor]
        mov ax, word ptr [buf_descriptor].descriptor._size
        mov word ptr [esi], ax
        mov eax, dword ptr [buf_descriptor].descriptor.base
        mov dword ptr [esi+2], eax

        add edi, SIZEOF descriptor
        add esi, SIZEOF descriptor

; -------- Place le mask sur le processeur suivant --------
        shl ebp, 1          ; place le mask sur le cpu suivant

    loop Boucle_save_all_idt_gdt  

; --------------------
; - Restore Affinity -
; --------------------

    GetCurrentThread eax
    push dword ptr [original_affinity]  ; ancien Mask
    push eax                            ; Thread
    call KeSetAffinityThread
        
    xor eax,eax             ; SUCCESS :)

sortie_save_all_idt_gdt :
    add esp, (3*4)
    mov dword ptr [esp+01Ch], eax
    popad
    ret (2*4)

erreur_save_all_idt_gdt :
    xor eax,eax
    inc eax                 ; AE :(
    jmp sortie_save_all_idt_gdt

